// contact me at xeen.reversestudios.com if you need help understanding the functions
var autosizerProgressListener = {
	QueryInterface: function(aIID) {
		if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
		  aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
		  aIID.equals(Components.interfaces.nsISupports))
		  return this;
		throw Components.results.NS_NOINTERFACE;
	},
	onProgressChange: function (aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {},
	onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) {},
	onSecurityChange: function(aWebProgress, aRequest, aState) {},
	onLinkIconAvailable: function(a) {},
	onStateChange: function (aWebProgress, aRequest, aStateFlags, aStatus) {},
	onLocationChange: function(aProgress, aRequest, aLocation) { if (aLocation) autosizer.genWidthCheck(false); }
}

function AutosizerPrefObserver() {
	autosizer.checkPrefs(false);
}

AutosizerPrefObserver.prototype = {
  observe: function(subject, topic, pref) {
		if (topic == 'nsPref:changed') autosizer.checkPrefs(false);
	}
};

var autosizer = {
	init: function() {  
		this.tooltipwidth=0;
		window.removeEventListener("load",function() { autosizer.init(); }, false);

		this.prefs = Components.classes["@mozilla.org/preferences-service;1"]
		               .getService(Components.interfaces.nsIPrefBranch)
		               .getBranch('browser.search.');
		this.initVar(); 
		
		this.txtOld=document.getElementById("searchbar");
		
		this.checkPrefs(true);
		this.getTooltipWidth();
		if (this.useMacFix 
		     && (Components.classes['@mozilla.org/xre/app-info;1'])
		     && (Components.interfaces.nsIXULAppInfo) 
		     && (Components.interfaces.nsIXULRuntime))
		  this.sBox.setAttribute('platform',Components.classes['@mozilla.org/xre/app-info;1']
		    .getService(Components.interfaces.nsIXULAppInfo)
		    .QueryInterface(Components.interfaces.nsIXULRuntime).OS.toLowerCase()); 		
   
		this.label.style.fontSize       = this.getStyle('font-size');
		this.label.style.fontSizeAdjust = this.getStyle('font-size-adjust');
		this.label.style.fontStretch    = this.getStyle('font-stretch');
		this.label.style.fontStyle      = this.getStyle('font-style');
		this.label.style.fontVariant    = this.getStyle('font-variant');
		this.label.style.fontWeight     = this.getStyle('font-weight');
		this.label.style.letterSpacing  = this.getStyle('letter-spacing');
		this.label.style.wordSpacing    = this.getStyle('word-spacing');

		window.addEventListener("load",function() { autosizer.genWidth(false); }, false);
		window.addEventListener("resize",function() { autosizer.genWidth(false); }, false);
		window.getBrowser().addProgressListener(autosizerProgressListener, Components.interfaces.nsIWebProgress.STATE_STOP);
		
	  if (this.prefs instanceof Components.interfaces.nsIPrefBranchInternal) {
			this.prefObserver = new AutosizerPrefObserver();
			this.prefs.addObserver('', this.prefObserver, false);
		}
		
		this.getAvailableWidth();
	}, 
	
	initVar: function() { 
		this.txt=document.getElementById("searchbar");
		this.sBox = document.getElementById("search-container");
		this.label=document.getElementById('autosizer-label'); 		
		this.input=document.getAnonymousElementByAttribute(this.txt, "anonid", "searchbar-textbox");
		this.input=document.getAnonymousElementByAttribute(this.input, "anonid", "textbox-input-box");
		this.diffWidth=(1+this.sBox.boxObject.width)-this.input.boxObject.width;  		  
		this.sBox.flex=0;
	},
	
	checkPrefs: function(startup) {   
    this.useMacFix=this.prefs.getBoolPref('useMacFix');
    this.offset=this.prefs.getIntPref('offset');
	  this.minwidth=this.prefs.getIntPref('minwidth');
		this.maxwidth=this.prefs.getIntPref('maxwidth');
		this.cleanOnSubmit=this.prefs.getBoolPref('cleanOnSubmit');
		
		if(!startup) setTimeout("autosizer.getTooltipWidth();autosizer.genWidth(false);",0);
	},

	getStyle: function(aProperty) { 
		return document.defaultView.getComputedStyle(this.input, '').getPropertyValue(aProperty);
	}, 
	
	getAvailableWidth: function() { 
		var toolbaritems=this.sBox.parentNode.childNodes,flextemp,i,x;
		this.neededWidth=0;
		for(i=0;x=toolbaritems[i];i++) {
			if(x.id=='search-container') continue;
			flextemp=x.getAttribute('flex');
			x.setAttribute('flex',0);
			this.neededWidth+=toolbaritems[i].boxObject.width;
			x.setAttribute('flex',flextemp);
		}
	}, 	

	genWidth: function(evt) {
		var availableWidth; 
	  if(evt && evt.keyCode!=40 && evt.keyCode!=33 && evt.keyCode!=38 && evt.keyCode!=34 && this.txt.value.length>this.label.value.length+1) window.setTimeout("autosizer.focusEnd();",0); // on insertion fix - avoid if items were inserted by autocomplete	 			
       
    availableWidth=window.outerWidth-this.neededWidth;     
    if(this.txt.getAttribute('empty')=='true') 
      this.label.value=''; // Avoid autosizing to search engine description if minwidth!=0
    else
    	this.label.value=this.txt.value;     
	  var width=this.label.boxObject.width+this.diffWidth+this.offset+9; // +9 explaination: If you type something in the searchbox, it is too narrow and moves the query to the left to display the just typed in letter. Once this is done, autosizer resizes the searchbar to its needed width. However, the text does not realign automatically. Therefore Autosizer would have to do so (like it does for the on insertion fix) but this procedure is quite slow which makes the typing look laggy. To prevent this, I just add 9 pixels to give enough space for the next letter. When done so, the searchbar is wide enough and it doesn't move the text. If 9 pixels is too less for your theme/language increase the "offset".
		if(width>this.maxwidth && this.maxwidth>0) width=this.maxwidth; // set max width 
		if(width<this.minwidth && this.minwidth>0) width=this.minwidth; // set min width
		if(width<this.tooltipwidth && this.minwidth==0) width=this.tooltipwidth; // set tooltip width (grey text)
		if(width>availableWidth && availableWidth>0) width=availableWidth; // available width
		if(width<this.diffWidth) width=this.diffWidth; // needed width	
    autosizer.sBox.width=width;
	},
	
	focusEnd: function() { 		
		var oEvent = document.createEvent('KeyEvents');  
		oEvent.initKeyEvent("keypress",true,true,null,false,false,false,false,oEvent.DOM_VK_BACK_SPACE ,0);
		autosizer.txt.value+=' ';
	  autosizer.input.dispatchEvent(oEvent);
	}, 
	
	getTooltipWidth: function() { 
		 if(this.minwidth>0) {
		 	 this.tooltipwidth=0;
		 	 return;
		 }
		 var temp=this.label.value;
     this.label.value=this.txt.getAttribute('tooltiptext');
     this.tooltipwidth=this.label.boxObject.width+this.diffWidth; 
     this.label.value=temp; 
	},     	

	genWidthCheck: function(evt) {
		this.initVar();     
		if(this.cleanOnSubmit && evt && evt.keyCode == 13) setTimeout("autosizer.txt.value='';autosizer.txt.empty='true';autosizer.genWidth();",0); 
		if(this.txtOld!=this.txt) {
			this.txtOld=document.getElementById("searchbar");
			this.getAvailableWidth();
		}
		if(this.label.value!=this.txt.value) this.genWidth(evt);
	},

	d: function(t) {
    //Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).logStringMessage('autosizer: '+t);
	}
}